<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Algorithm &mdash; anonym anonym documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="_static/jquery.js?v=5d32c60e"></script>
        <script src="_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="_static/documentation_options.js?v=14175b09"></script>
        <script src="_static/doctools.js?v=888ff710"></script>
        <script src="_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Import and saving" href="Import%20and%20save.html" />
    <link rel="prev" title="Installation" href="Installation.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="index.html" class="icon icon-home">
            anonym
          </a>
              <div class="version">
                0.1.1
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
    
              <p class="caption" role="heading"><span class="caption-text">Installation</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="Installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="Installation.html#uninstalling">Uninstalling</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Methods</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="current reference internal" href="#">Algorithm</a></li>
<li class="toctree-l1"><a class="reference internal" href="#named-entity-recognition-catagories">Named Entity Recognition Catagories</a></li>
<li class="toctree-l1"><a class="reference internal" href="#faking-the-data-entries">Faking the data entries</a></li>
<li class="toctree-l1"><a class="reference internal" href="Import%20and%20save.html">Import and saving</a></li>
<li class="toctree-l1"><a class="reference internal" href="Import%20and%20save.html#import-from-csv">Import from csv</a></li>
<li class="toctree-l1"><a class="reference internal" href="Import%20and%20save.html#saving-to-csv">Saving to csv</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Examples</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="Examples.html">Quickstart to anonym your data set</a></li>
<li class="toctree-l1"><a class="reference internal" href="Examples.html#anonymize-data-set-with-user-defined-specifications">Anonymize data set with user defined specifications</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Documentation</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="Documentation.html">Github</a></li>
<li class="toctree-l1"><a class="reference internal" href="Documentation.html#colab-notebook">Colab Notebook</a></li>
<li class="toctree-l1"><a class="reference internal" href="Coding%20quality.html">Coding quality</a></li>
<li class="toctree-l1"><a class="reference internal" href="anonym.anonym.html">API References</a></li>
</ul>

    <a href= "genindex.html">Index</a>
  
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">anonym</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Algorithm</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/Algorithm.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="algorithm">
<h1>Algorithm<a class="headerlink" href="#algorithm" title="Link to this heading"></a></h1>
<p>The <code class="docutils literal notranslate"><span class="pre">anonym</span></code> algorithm is designed to anonymize data in a DataFrame. It works by replacing real data with fake data, while maintaining the structure and format of the original data. Here’s a step-by-step explanation of how it works:</p>
<blockquote>
<div><p><strong>1. Initialization</strong>: The anonym class is initialized with a language parameter (default is ‘dutch’) and a verbosity level (default is ‘info’). The language parameter is used to load the appropriate language model for named entity recognition (NER), and the verbosity level sets the logger’s verbosity.</p>
<p><strong>2. Data Import</strong>: The import_data method is used to import a dataset from a given file path. The data is read into a pandas DataFrame.</p>
<p><strong>3. Data Anonymization</strong>: The anonymize method is the core of the algorithm. It takes a DataFrame and optional parameters for specifying columns to fake or not to fake, and a NER blacklist. The method works as follows:</p>
<p><strong>4. It calls the extract_entities function</strong> to extract all entities from the DataFrame. This function uses the <code class="docutils literal notranslate"><span class="pre">spacy</span></code> library’s NER capabilities to identify entities in the data. If a column is specified in the fakeit parameter, the entities in that column are replaced with the specified fake replacement. If a column is specified in the do_not_fake parameter, it is left untouched. Otherwise, NER is performed on each row of the column.</p>
<p><strong>5. The generate_fake_labels function</strong> is then called to generate fake labels for the extracted entities. This function uses the <code class="docutils literal notranslate"><span class="pre">faker</span></code> library to generate fake data that matches the type of the original data (e.g., names, companies, dates, cities, etc.).</p>
<p><strong>6. The replace_label_with_fake function</strong> is then used to replace the original entities in the DataFrame with the generated fake labels.</p>
<p><strong>7. Data Export</strong>: The to_csv method is used to write the anonymized DataFrame to a CSV file.</p>
<p><strong>8. Example Data Import</strong>: The import_example method is used to import example datasets from a GitHub source or a specified URL.</p>
</div></blockquote>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>Start
<span class="w">  </span><span class="p">|</span>
<span class="w">  </span>v
Initialize<span class="w"> </span><span class="sb">`</span>anonym<span class="sb">`</span><span class="w"> </span>class
<span class="w">  </span><span class="p">|</span>
<span class="w">  </span>v
Import<span class="w"> </span>data<span class="w"> </span>using<span class="w"> </span><span class="sb">`</span>import_data<span class="sb">`</span><span class="w"> </span>method
<span class="w">  </span><span class="p">|</span>
<span class="w">  </span>v
Anonymize<span class="w"> </span>data<span class="w"> </span>using<span class="w"> </span><span class="sb">`</span>anonymize<span class="sb">`</span><span class="w"> </span>method
<span class="w">  </span><span class="p">|</span><span class="w">         </span><span class="p">|</span>
<span class="w">  </span><span class="p">|</span><span class="w">         </span>v
<span class="w">  </span><span class="p">|</span><span class="w">     </span>Extract<span class="w"> </span>entities<span class="w"> </span>using<span class="w"> </span><span class="sb">`</span>extract_entities<span class="sb">`</span><span class="w"> </span><span class="k">function</span>
<span class="w">  </span><span class="p">|</span><span class="w">         </span><span class="p">|</span>
<span class="w">  </span><span class="p">|</span><span class="w">         </span>v
<span class="w">  </span><span class="p">|</span><span class="w">     </span>Generate<span class="w"> </span>fake<span class="w"> </span>labels<span class="w"> </span>using<span class="w"> </span><span class="sb">`</span>generate_fake_labels<span class="sb">`</span><span class="w"> </span><span class="k">function</span>
<span class="w">  </span><span class="p">|</span><span class="w">         </span><span class="p">|</span>
<span class="w">  </span><span class="p">|</span><span class="w">         </span>v
<span class="w">  </span><span class="p">|</span><span class="w">     </span>Replace<span class="w"> </span>original<span class="w"> </span>labels<span class="w"> </span>with<span class="w"> </span>fake<span class="w"> </span>ones<span class="w"> </span>using<span class="w"> </span><span class="sb">`</span>replace_label_with_fake<span class="sb">`</span><span class="w"> </span><span class="k">function</span>
<span class="w">  </span>v
Export<span class="w"> </span>anonymized<span class="w"> </span>data<span class="w"> </span>using<span class="w"> </span><span class="sb">`</span>to_csv<span class="sb">`</span><span class="w"> </span>method
<span class="w">  </span><span class="p">|</span>
<span class="w">  </span>v
End
</pre></div>
</div>
<p>The algorithm also includes several utility functions for text cleaning, preprocessing, filtering values, checking the <code class="docutils literal notranslate"><span class="pre">spacy</span></code> model, and setting the logger. The main function at the end of the script demonstrates how to use the anonym class to import an example dataset, anonymize it, and plot the results.</p>
</section>
<section id="named-entity-recognition-catagories">
<h1>Named Entity Recognition Catagories<a class="headerlink" href="#named-entity-recognition-catagories" title="Link to this heading"></a></h1>
<p>The available Named Entity Recognition (NER) categories in the anonym algorithm are determined by the underlying <code class="docutils literal notranslate"><span class="pre">spacy</span></code> library. Here are the categories used in the anonym algorithm:</p>
<table class="docutils align-default" id="id1">
<caption><span class="caption-text">Named Entity Recognition (NER) Categories</span><a class="headerlink" href="#id1" title="Link to this table"></a></caption>
<colgroup>
<col style="width: 25%" />
<col style="width: 75%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>Abbreviation</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>PERSON</p></td>
<td><p>People, including fictional.</p></td>
</tr>
<tr class="row-odd"><td><p>ORG</p></td>
<td><p>Companies, agencies, institutions, etc.</p></td>
</tr>
<tr class="row-even"><td><p>DATE</p></td>
<td><p>Absolute or relative dates or periods.</p></td>
</tr>
<tr class="row-odd"><td><p>LOC</p></td>
<td><p>Non-GPE locations, mountain ranges, bodies of water.</p></td>
</tr>
<tr class="row-even"><td><p>MONEY</p></td>
<td><p>Monetary values, including unit.</p></td>
</tr>
<tr class="row-odd"><td><p>NORP</p></td>
<td><p>Nationalities or religious or political groups.</p></td>
</tr>
<tr class="row-even"><td><p>ADDRESS</p></td>
<td><p>Addresses of any kind.</p></td>
</tr>
<tr class="row-odd"><td><p>GPE</p></td>
<td><p>Countries, cities, states.</p></td>
</tr>
<tr class="row-even"><td><p>EVENT</p></td>
<td><p>Named hurricanes, battles, wars, sports events, etc.</p></td>
</tr>
<tr class="row-odd"><td><p>WORK_OF_ART</p></td>
<td><p>Titles of books, songs, etc.</p></td>
</tr>
<tr class="row-even"><td><p>LAW</p></td>
<td><p>Named documents made into laws.</p></td>
</tr>
</tbody>
</table>
<p>Each of these categories is associated with a specific fake data generation function from the <code class="docutils literal notranslate"><span class="pre">faker</span></code> library. For example, ‘PERSON’ entities are replaced with fake names, ‘ORG’ entities are replaced with fake company names, ‘DATE’ entities are replaced with fake dates, and so on.</p>
<p>Please note that the algorithm also allows for a NER blacklist, which is a list of NER labels to be ignored during the anonymization process. By default, this list includes ‘CARDINAL’, ‘GPE’, ‘PRODUCT’, and ‘DATE’.</p>
</section>
<section id="faking-the-data-entries">
<h1>Faking the data entries<a class="headerlink" href="#faking-the-data-entries" title="Link to this heading"></a></h1>
<p>The data is faked in the anonym algorithm using the <code class="docutils literal notranslate"><span class="pre">faker</span></code> library, which is a Python package that generates fake data. Here’s a summary of how the data is faked:</p>
<blockquote>
<div><p><strong>1. Entity Extraction</strong>: The algorithm first identifies entities in the data using Named Entity Recognition (NER) from the spacy library. This process identifies pieces of text that represent certain types of information, such as names, dates, or addresses.</p>
<p><strong>2. Fake Data Generation</strong>: For each identified entity, the algorithm generates a corresponding piece of fake data. The type of fake data generated depends on the type of the entity. For example, if the entity is a person’s name, the algorithm generates a fake name. If the entity is a date, the algorithm generates a fake date. This is done using the <code class="docutils literal notranslate"><span class="pre">faker</span></code> library, which has functions for generating various types of fake data.</p>
<p><strong>3. Replacement</strong>: Once the fake data is generated, the algorithm replaces the original entities in the data with the generated fake data. This is done in such a way that the structure and format of the data remain the same, only the actual content is changed.</p>
<p><strong>4. Blacklist</strong>: The algorithm also allows for a blacklist of entity types that should not be faked. If an entity type is in the blacklist, it will be ignored and left as is in the data.</p>
</div></blockquote>
<p>By using this process, the anonym algorithm can effectively anonymize data by replacing real, potentially sensitive information with fake, nonsensitive information.</p>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="Installation.html" class="btn btn-neutral float-left" title="Installation" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="Import%20and%20save.html" class="btn btn-neutral float-right" title="Import and saving" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Data en Innovatielab (IenW).</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>